#ifndef __CGI_H__
#define __CGI_H__

#include "http.h"
#include "hash.h"
#include "rope.h"
#include "smalloc.h"

#define CGI_HASHSIZE (37)

// void	 cgi_error(char *str);
// void	 cgi_fatal(char *str);
rope_t	*cgi_rope_new(void);
hash_t	*cgi_hash_new(void);
char	*cgi_url_encode(char *str);
char	*cgi_url_decode(char *str);
char	*cgi_html_encode(char *str);

#define cgi_base64_decode(x) (sstrdup(HTUnEscape(x)))
#define cgi_base64_encode(x) (HTEscape(x))

#endif
